Overview | Package | Class | Tree | Deprecated | Index | Help
| © 2004 BEA Systems, Inc.
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.bea.netuix.application.manager
Interface IPortalDefinitionManager

All Known Subinterfaces:
  PortalDefinitionManager

public interface IPortalDefinitionManager

Defines methods to manage a hierarchy of `PortalDefinition`s. Assumes that the hierarchy is a top down tree with each portal having only one parent portal. However, the same `PortalDefinition` can reside under multiple portals.
Imposes only a one level hierarchy of `PortalDefinition`s i.e. all `PortalDefinitions`s have to be first level children of the root `PortalDefinition` and cannot have chidren of their own. Also disallows the root `PortalDefinition` to have any `DesktopDefinition`s categorized under it. "Definitions" can be thought of as objects in the Library. Objects in the library are not associated to any one Desktop. In other words definitions can be placed on zero or more desktops and changes made in the Library (to the definitions) are cascaded down to object on the desktops. If you are only interested in effecting a single desktop then use the `PortalCustomizationManager` and make changes to the "Instances".

Method Summary
`PortalDefinition` | `createPortalDefinition(CustomizationContext customizationContext, PortalDefinition pd)` Creates a persistent version of a `PortalDefinition` from the provided `PortalDefinition`.
`int` | `deletePortalDefinition(CustomizationContext customizationContext, PortalPath portalPath, String webapp)` Deletes a PortalDefinition.
`DefinitionCount` | `getDefinitionCount(CustomizationContext customizationContext, boolean _public)` Return a count of all the definitions in the system.
`int` | `getDesktopDefinitionCount(CustomizationContext customizationContext, PortalPath portalPath, String webapp)` Returns the number of `DesktopDefinition`s under `portal` `portalPath`.
`PortalPath[]` | `getDesktopDefinitionPortals(CustomizationContext customizationContext, DesktopPath desktopPath, String webapp)` Returns all the `PortalPath`s that a `DesktopDefinition` is a part of.
`DesktopDefinition[]` | `getDesktopDefinitions(CustomizationContext customizationContext, PortalPath portalPath, int begin, int end, String webapp)` Returns `DesktopDefinition`s in the `begin` and `end` range under the portal `portalPath`.
`DesktopView[]` | `getDesktopViews(CustomizationContext customizationContext, PortalPath portalPath, int begin, int end, String webapp)` Returns `DesktopView`s in the `begin` and `end` range under the portal `portalPath`.
`PortalDefinition` | `getPortalDefinition(CustomizationContext customizationContext, PortalPath portalPath, String webapp)` Returns a `PortalDefinition` corresponding to a `PortalPath`.
`int` | `getPortalDefinitionCount(CustomizationContext customizationContext, String webapp)` Returns the number of portals.
`PortalDefinition[]` | `getPortalDefinitions(CustomizationContext customizationContext, PortalPath[] portalPaths, String webapp)` Returns an array of `PortalDefinition`s corresponding to an array of `PortalPath`s.
`PortalView` | `getPortalDefinitionView(CustomizationContext customizationContext, PortalPath portalPath, String webapp)` Returns a `PortalView` corresponding to a `PortalPath`.
`PortalView[]` | `getPortalDefinitionViews(CustomizationContext customizationContext, PortalPath[] portalPaths, String webapp)` Returns an array of `PortalView`s corresponding to an array of `PortalPath`s.
`PortalPath[]` | `getPortalPaths(CustomizationContext customizationContext, int begin, int end, String webapp)` Returns an array of `PortalPath`s in the `begin` and `end` range.
`String[]` | `getPortalWebApps(CustomizationContext customizationContext)` Return a set of portal webapps that are `customizable`.
`void` | `updatePortalDefinition(CustomizationContext customizationContext, PortalPath portalPath, PortalDefinition newPd)` Updates a PortalDefinition based on a new PortalDefinition.

Method Detail

### getPortalWebApps

    public String[] getPortalWebApps(CustomizationContext customizationContext)
                              throws RemoteException

  Return a set of portal webapps that are `customizable`. Customizable webapps are webapps with `customization` element set to true in the netuix-config.xml file, and have at least on of the following: .shell files.

  Parameters:
    `customizationContext` -
  Returns:
    an array of webapp names.
  Throws:
    `RemoteException`

### getDefinitionCount

    public DefinitionCount getDefinitionCount(CustomizationContext customizationContext,
                                              boolean _public)
                                       throws RemoteException

  Return a count of all the definitions in the system.

  Parameters:
    `customizationContext` -
    `_public` - if true only return `public` definitions
  Returns:
    a class containing all the definitions counts
  Throws:
    `RemoteException`

### getPortalDefinitionCount

    public int getPortalDefinitionCount(CustomizationContext customizationContext,
                                        String webapp)
                                 throws RemoteException

  Returns the number of portals.

  Parameters:
    `webapp` - web application these desktop definitions are scoped to.
  Returns:
    number of portals
  Throws:
    `RemoteException`

### getPortalDefinition

    public PortalDefinition getPortalDefinition(CustomizationContext customizationContext,
                                                PortalPath portalPath,
                                                String webapp)
                                         throws RemoteException,
                                                ObjectNotFoundException

  Returns a `PortalDefinition` corresponding to a `PortalPath`.

  Parameters:
    `customizationContext` - customization information such as prefered locales
    `portalPath` - `PortalPath`
    `webapp` - web application these desktop definitions are scoped to.
  Returns:
    `PortalDefinition`
  Throws:
    `ObjectNotFoundException` - if no portal is found
    `RemoteException`

### getPortalDefinitionView

    public PortalView getPortalDefinitionView(CustomizationContext customizationContext,
                                              PortalPath portalPath,
                                              String webapp)
                                       throws RemoteException,
                                              ObjectNotFoundException

  Returns a `PortalView` corresponding to a `PortalPath`.
  NOTE: This method returns a deep copy of a portal definition.

  Parameters:
    `customizationContext` - customization information such as prefered locales
    `portalPath` - `PortalPath`
    `webapp` - web application these desktop definitions are scoped to.
  Returns:
    `PortalView`
  Throws:
    `ObjectNotFoundException` - if no category definition is found
    `RemoteException`

### getPortalPaths

    public PortalPath[] getPortalPaths(CustomizationContext customizationContext,
                                       int begin,
                                       int end,
                                       String webapp)
                                throws RemoteException

  Returns an array of `PortalPath`s in the `begin` and `end` range. If fewer portals than (begin-end) exist then the former number of portals is returned. If no definitions are found an empty array is returned.
  Implementation has to ensure that repeated calls to this method return `PortalPath`s in a consistent order.

  Parameters:
    `customizationContext` - customization information such as prefered locales
    `begin` - begin index
    `end` - end index
    `webapp` - web application these desktop definitions are scoped to.
  Returns:
    an array of `PortalPath`s
  Throws:
    `RemoteException`

### getPortalDefinitions

    public PortalDefinition[] getPortalDefinitions(CustomizationContext customizationContext,
                                                   PortalPath[] portalPaths,
                                                   String webapp)
                                            throws RemoteException,
                                                   ObjectNotFoundException

  Returns an array of `PortalDefinition`s corresponding to an array of `PortalPath`s.

  Parameters:
    `customizationContext` - customization information such as prefered locales
    `portalPaths` - array of `PortalPath`s. If null return all portal definitions
    `webapp` - web application these desktop definitions are scoped to.
  Returns:
    array of `PortalDefinition`s
  Throws:
    `ObjectNotFoundException` - if portal for any key does not exist
    `RemoteException`

### getPortalDefinitionViews

    public PortalView[] getPortalDefinitionViews(CustomizationContext customizationContext,
                                                 PortalPath[] portalPaths,
                                                 String webapp)
                                          throws RemoteException,
                                                 ObjectNotFoundException

  Returns an array of `PortalView`s corresponding to an array of `PortalPath`s.

  Parameters:
    `customizationContext` - customization information such as prefered locales
    `portalPaths` - array of `PortalPath`s
    `webapp` - web application these desktop definitions are scoped to.
  Returns:
    array of `PortalView`s
  Throws:
    `ObjectNotFoundException` - if portal for any key does not exist
    `RemoteException`

### getDesktopDefinitionCount

    public int getDesktopDefinitionCount(CustomizationContext customizationContext,
                                         PortalPath portalPath,
                                         String webapp)
                                  throws RemoteException

  Returns the number of `DesktopDefinition`s under `portal` `portalPath`.

  Parameters:
    `portalPath` - `PortalPath`
    `webapp` - web application these desktop definitions are scoped to.
  Returns:
    number of `PortletDefinition`s under portal represented by `portalPath`
  Throws:
    `RemoteException`

### getDesktopDefinitions

    public DesktopDefinition[] getDesktopDefinitions(CustomizationContext customizationContext,
                                                     PortalPath portalPath,
                                                     int begin,
                                                     int end,
                                                     String webapp)
                                              throws RemoteException

  Returns `DesktopDefinition`s in the `begin` and `end` range under the portal `portalPath`. If fewer `DesktopDefinition`s than (begin-end) exist then the former number is returned. If no definitions are found an empty array is returned.
  Use this method after getting the number of `DesktopDefinition`s.
  Implementation has to ensure that repeated calls to this method return `DesktopDefinition`s in a consistent order.

  Parameters:
    `customizationContext` - customization information such as prefered locales
    `portalPath` - `PortalPath`
    `begin` - begin index
    `end` - end index
    `webapp` - web application these desktop definitions are scoped to.
  Returns:
    array of `DesktopDefinition`s
  Throws:
    `RemoteException`

### getDesktopViews

    public DesktopView[] getDesktopViews(CustomizationContext customizationContext,
                                         PortalPath portalPath,
                                         int begin,
                                         int end,
                                         String webapp)
                                  throws RemoteException,
                                         ObjectNotFoundException

  Returns `DesktopView`s in the `begin` and `end` range under the portal `portalPath`. If fewer views than (begin-end) exist then the former number of views is returned. If no views are found an empty array is returned.
  Use this method after getting the number of `DesktopDefinition`s.
  Implementation has to ensure that repeated calls to this method return `DesktopView`s in a consistent order.

  Parameters:
    `customizationContext` - customization information such as prefered locales
    `portalPath` - `PortalPath`
    `begin` - begin index
    `end` - end index
    `webapp` - web application these desktop definitions are scoped to.
  Returns:
    array of `DesktopView`s
  Throws:
    `RemoteException`
    `ObjectNotFoundException`

### getDesktopDefinitionPortals

    public PortalPath[] getDesktopDefinitionPortals(CustomizationContext customizationContext,
                                                    DesktopPath desktopPath,
                                                    String webapp)
                                             throws RemoteException

  Returns all the `PortalPath`s that a `DesktopDefinition` is a part of. Returns an empty array if the latter is noncategorized.

  Parameters:
    `desktopPath` - `DesktopPath`
    `webapp` - web application these desktop definitions are scoped to.
  Returns:
    an array of `PortalPath`s
  Throws:
    `RemoteException`

### createPortalDefinition

    public PortalDefinition createPortalDefinition(CustomizationContext customizationContext,
                                                   PortalDefinition pd)
                                            throws RemoteException,
                                                   NotEntitledException,
                                                   MissingDataException,
                                                   DuplicateObjectException

  Creates a persistent version of a `PortalDefinition` from the provided `PortalDefinition`.

  Parameters:
    `customizationContext` - customization information such as prefered locales
    `pd` - `PortalDefinition`
  Returns:
    handle to persisted `PortalDefinition`
  Throws:
    `NotEntitledException` - if caller does not have permission for this operation
    `MissingDataException` - if data required to create a portal is missing
    `DuplicateObjectException` - if this or another webapp already has a portal with the same partial path
    `RemoteException`

### deletePortalDefinition

    public int deletePortalDefinition(CustomizationContext customizationContext,
                                      PortalPath portalPath,
                                      String webapp)
                               throws RemoteException,
                                      NotEntitledException

  Deletes a PortalDefinition.

  Parameters:
    `customizationContext` - customization information such as prefered locales
    `portalPath` - PortalPath for PortalDefinition to be removed
    `webapp` - web application these desktop definitions are scoped to.
  Returns:
    number of portals deleted
  Throws:
    `NotEntitledException` - if caller does not have permission for this operation
    `RemoteException`

### updatePortalDefinition

    public void updatePortalDefinition(CustomizationContext customizationContext,
                                       PortalPath portalPath,
                                       PortalDefinition newPd)
                                throws RemoteException,
                                       ObjectNotFoundException,
                                       ObjectInUseException,
                                       NotEntitledException,
                                       MissingDataException

  Updates a PortalDefinition based on a new PortalDefinition.

  Parameters:
    `customizationContext` - customization information such as prefered locales
    `portalPath` - PortalPath to PortalDefinition to be updated
    `newPd` - new PortalDefinition
  Throws:
    `ObjectNotFoundException` - if portal does not exist
    `NotEntitledException` - if caller does not have permission for this operation
    `MissingDataException` - if data required to update a portal is missing
    `RemoteException`
    `ObjectInUseException`

Overview | Package | Class | Tree | Deprecated | Index | Help
| © 2004 BEA Systems, Inc.
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2004 BEA Systems, Inc. All Rights Reserved